@mixin btn-default {
  border-radius: $gl-border-radius-base;
  font-size: $gl-font-size;
  font-weight: $gl-font-weight-normal;
  padding: $gl-vert-padding $gl-btn-padding;

  &:focus,
  &:active {
    background-color: $btn-active-gray;
  }
}

@mixin btn-outline($background, $text, $border, $hover-background, $hover-text, $hover-border, $active-background, $active-border, $active-text) {
  background-color: $background;
  color: $text;
  border-color: $border;

  > .icon {
    color: $text;
  }

  &:hover,
  &:focus {
    background-color: $hover-background;
    border-color: $hover-border;
    color: $hover-text;

    > .icon {
      color: $hover-text;
    }
  }

  &:focus {
    box-shadow: 0 0 4px 1px $blue-300;
  }

  &:active {
    background-color: $active-background;
    border-color: $active-border;
    box-shadow: inset 0 2px 4px 0 rgba($black, 0.2);
    color: $active-text;

    > .icon {
      color: $active-text;
    }

    &:focus {
      box-shadow: inset 0 2px 4px 0 rgba($black, 0.2);
    }
  }
}

@mixin btn-color($light, $border-light, $normal, $border-normal, $dark, $border-dark, $color) {
  background-color: $light;
  border-color: $border-light;
  color: $color;

  &:hover,
  &:focus {
    background-color: $normal;
    border-color: $border-normal;
    color: $color;
  }

  &:active,
  &.active {
    background-color: $dark;
    border-color: $border-dark;
    color: $color;
  }
}

@mixin btn-with-margin {
  margin-left: $gl-spacing-scale-3;
  float: left;

  &.inline {
    float: none;
  }
}

.btn {
  @include btn-default;
  @include btn-color($white, $gray-200, $gray-50, $gray-200, $gray-100, $gray-300, $gl-text-color);

  color: $gl-text-color;
  white-space: nowrap;

  &:focus:active {
    outline: 0;
  }

  &.btn-sm {
    padding: 4px 10px;
    font-size: $gl-btn-small-font-size;
    line-height: $gl-btn-small-line-height;
  }

  &.btn-inverted:not(.disabled):not(:disabled) {
    &.btn-danger {
      @include btn-outline($white, $red-500, $red-500, $red-100, $red-700, $red-500, $red-200, $red-600, $red-800);
    }
  }

  &.btn-danger {
    @include btn-color($red-500, $red-600, $red-600, $red-700, $red-700, $red-800, $white-contrast);
  }

  &.btn-grouped {
    @include btn-with-margin;
  }

  &.btn-icon {
    color: $gray-700;
  }

  svg {
    height: 15px;
    width: 15px;
  }

  svg:not(:last-child) {
    margin-right: 5px;
  }
}

.btn-transparent {
  color: var(--gl-button-default-primary-foreground-color-default);
  background-color: transparent;
  border: 0;

  &:hover,
  &:active,
  &:focus {
    background-color: transparent;
  }
}

.btn-group {
  &.btn-grouped {
    @include btn-with-margin;
  }
}

.input-group-prepend,
.input-group-append {
  .btn {
    @include btn-default;

    &:hover {
      outline: none;
    }

    &:active {
      outline: none;
    }
  }

  .active {
    box-shadow: $gl-btn-active-background;

    border: 1px solid $gray-100 !important;
    background-color: $btn-active-gray-light !important;
  }
}

// All disabled buttons, regardless of color, type, etc
.btn.disabled,
.btn[disabled],
fieldset[disabled] .btn,
.dropdown-toggle[disabled],
[disabled].dropdown-menu-toggle {
  &,
  &:hover {
    background-color: $gray-10;
    border-color: $gray-100;
    @apply gl-text-disabled;
    opacity: 1;
    text-decoration: none;
    cursor: default;

    &.cursor-not-allowed {
      cursor: not-allowed;
    }

    i {
      @apply gl-text-disabled;
    }
  }
}
